#!/usr/bin/perl
#
# dcboard97.cgi
# Part of DCForum97n by DCScripts
# Written By David S. Choi, dc@sitedeveloper.com
# 10 August 1997
#
# Copyright  1997 DCScripts All Rights Reserved
# As part of the installation process, you will be asked
# to accept the terms of this Agreement. This Agreement is
# a legal contract, which specifies the terms of the license
# and warranty limitation between you and DCScripts and DCForum97.
# You should carefully read the following terms and conditions before
# installing or using this software.  Unless you have a different license
# agreement obtained from DCScripts, installation or use of this software
# indicates your acceptance of the license and warranty limitation terms
# contained in this Agreement. If you do not agree to the terms of this
# Agreement, promptly delete and destroy all copies of the Software.
#
# Versions of the Software 
# Only one copy of the registered version of DCForum97 may used on one web site.
# 
# License to Redistribute
# Distributing the software and/or documentation with other products
# (commercial or otherwise) or by other than electronic means without
# DCScripts's prior written permission is forbidden.
# All rights to the DCForum97 software and documentation not expressly
# granted under this Agreement are reserved to DCScripts.
#
# Disclaimer of Warranty
# THIS SOFTWARE AND ACCOMPANYING DOCUMENTATION ARE PROVIDED "AS IS" AND
# WITHOUT WARRANTIES AS TO PERFORMANCE OF MERCHANTABILITY OR ANY OTHER
# WARRANTIES WHETHER EXPRESSED OR IMPLIED.   BECAUSE OF THE VARIOUS HARDWARE
# AND SOFTWARE ENVIRONMENTS INTO WHICH DCFORUM97 MAY BE USED, NO WARRANTY OF
# FITNESS FOR A PARTICULAR PURPOSE IS OFFERED.  THE USER MUST ASSUME THE
# ENTIRE RISK OF USING THIS PROGRAM.  ANY LIABILITY OF HKDESIGN WILL BE
# LIMITED EXCLUSIVELY TO PRODUCT REPLACEMENT OR REFUND OF PURCHASE PRICE.
# IN NO CASE SHALL DCSCRIPTS BE LIABLE FOR ANY INCIDENTAL, SPECIAL OR
# CONSEQUENTIAL DAMAGES OR LOSS, INCLUDING, WITHOUT LIMITATION, LOST PROFITS
# OR THE INABILITY TO USE EQUIPMENT OR ACCESS DATA, WHETHER SUCH DAMAGES ARE
# BASED UPON A BREACH OF EXPRESS OR IMPLIED WARRANTIES, BREACH OF CONTRACT,
# NEGLIGENCE, STRICT TORT, OR ANY OTHER LEGAL THEORY. THIS IS TRUE EVEN IF
# DCSCRIPTS IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. IN NO CASE WILL
# DCSCRIPTS' LIABILITY EXCEED THE AMOUNT OF THE LICENSE FEE ACTUALLY PAID
# BY LICENSEE TO DCSCRIPTS. 
#
# CREDITS:
# The authentication code is the work of Selena Sol and Gunther Berznick
# You can obtain it from Selena Sol's Public Domain Script Archive
# at http://selena.mcp.com/Scripts/ or you can purchase their book
# "Instant Web Scripts with CGI/PERL" -- Great Book!
# cgi-lib.pl was written by Stephen Brenner.
#------------------------------------------------------

# NOTE: You may need to provide full path to each setup files
# Some server require this.

# Bibliotheken
$path = "/vserv/g/gb-dire1/cgi-bin/dcforum97";
$libra = $path . "/Library";

require "$path/dcforum97.setup";
require "$path/dcboard97.setup";
require "$libra/cgi-lib.pl";
require "$libra/cgi-lib.sol";

print &PrintHeader;

# Formulareingaben lesen
&ReadParse;

&get_variables;

foreach ($j = 0;$j <= 99;$j++)
{
	if ($in{"$j.x"} ne "")
	{
		$rt = $j;
		$az = "post";
		last;
	}
}

# Einlesen der Link-Auflsitung der Foren

&forum_links;

# Auflistung
if ($in{"Main.x"} ne "")
{
	$az="list";
}

# Vorschau
elsif ($in{"preview_option"} ne "")
{
	$az = "pview";
}

# Absenden
elsif ($in{"post_option"} ne "")
{
	$az = "a_mesg";
}

# Hauptmen
elsif ($in{"az"} ne "")
{
	$az = $in{"az"};
}

# Neuer Beitrag
if ($az eq "post")
{
	srand;
	$rand1 = int(rand 1000000) + 1;
	open(DUMMYFILE,">$auth_session_dir/$rand1\.dat") || die $!;
	print DUMMYFILE "0";
	close(DUMMYFILE);
	&post;
}

# Vorschau
elsif ($az eq "pview")
{
	&get_form_variables;
	&get_date;
	&display_status("pview");
}

# Neue Beitraege
elsif ($az eq "n_mesg")
{
	$days = $in{"days"};
	&get_date;
	&create_button("new_mesg");
	&new_messages;
}

# Beitraege auflisten
elsif ($az eq "a_mesg")
{
	$rand1 = $in{"rand1"};
	if (-e "$auth_session_dir/$rand1\.dat")
	{
		&get_form_variables;
		&get_date;
		if ($om == 0)
		{
			&get_number;
			&add_message;
			&create_message;
		}
		else
		{
			&update_database;
			&thread_message;
		}
		unlink("$auth_session_dir/$rand1\.dat");
	}
	&create_button("list");
	&list;
}

# Auflistung
elsif ($az eq "list")
{
	&create_button("list");
	&list;
}

# Hauptmenue
else
{
	&create_button("list_forums");
	&list_forums;
}

require "$templateurl";

exit(0);

#-------------------------------------------
# Subroutine list_forums
#-------------------------------------------

sub list_forums
{
	$heading = $heading_list_forums;
	$sub_heading = $sub_heading_list_forums;   

	$sub_heading .= qq~
<FORM METHOD="POST" ACTION="$boardurl">
	<INPUT TYPE="HIDDEN" NAME="az" VALUE="n_mesg">
	<FONT SIZE="2"> Lesen neuer Mitteilungen der letzten
	<SELECT NAME="days">
		<OPTION>1</OPTION>
		<OPTION>2</OPTION>
		<OPTION>3</OPTION>
		<OPTION>4</OPTION>
		<OPTION>5</OPTION>
	</SELECT>
Tage.
<INPUT TYPE="SUBMIT" NAME="submit" VALUE="Jetzt!">
</FONT>
</FORM>~;
	$html_output = "";
   
	$html_output .= qq~
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="3">
	<TR>
		<TD COLSPAN="3">$separator_img<BR></TD>
	</TR>~;
   
	foreach $forum (@forums)
	{
		open(DATA,"$maindir/$forum/$database") || die $!;
		flock(DATA,2);
		@rowdata = <DATA>;
		flock(DATA,8);
		close(DATA);

		$num_messages = @rowdata;
		$thread = $num_messages == 1 ? "Zweig" : "Zweige";

		$html_output .= qq~
	<TR>
		<TD ALIGN="LEFT" VALIGN="TOP">
			<img src="$imgurl/folder.gif">
			<a href="$boardurl?az=list&forum=$forum"><FONT FACE="times, serif, palatino" SIZE="2"><B>$forum_name{$forum}</B></FONT></A>
		</TD>
		<TD ALIGN="LEFT" VALIGN="TOP">
			<FONT FACE="verdana, arial, helvetica" SIZE="2" COLOR="#BB0033">($num_messages $thread)</FONT>
		</TD>
		<TD ALIGN="LEFT" VALIGN="TOP">
			<FONT FACE="verdana, arial, helvetica" SIZE="2">$forum_desc{$forum}</FONT>
		</TD>
	</TR>~;
	}

	$html_output .= qq~
	<TR>
		<TD COLSPAN="3"><IMG SRC="$separator_img" BORDER="0" WIDTH="100%" HEIGHT="2"></TD>
	</TR>
</TABLE>~;

}


#-----------------------------------------
# Subroutine list
#-----------------------------------------

sub list
{
	open(DATA,"$maindir/$forum/$database") || die $!;
	flock(DATA,2);
	@rowdata = <DATA>;
	flock(DATA,8);
	close(DATA);

	$num_messages = @rowdata;
   
	$heading = "Beitrge im Forum <i>\'$forum_name{\"$forum\"}\'</i>\n";

	$start = $mm + 1;
	$stop = $mm + $mesg_max;

	if ($stop > $num_messages)
	{
		$stop = $num_messages;
	}
   
	$sub_heading = "Beitrag $start-$stop von $num_messages Beitrgen\n";

	$html_output = "";

	$html_output .=qq~
<a name="TOP">$separator_img</a>
<CENTER>
<TABLE BORDER="0" CELLPADDING="0" WIDTH="100%">~;

	&get_table_heading;

	$html_output .= $table_heading;
   
	foreach ($j = 1; $j <= $mesg_max; $j++)
	{
		if (($j + $mm - 1) < $num_messages)
		{
			$row = $rowdata[$j + $mm - 1];
			($num,$date,$localtime,$name,$subject,$replies) = split(/\|/, $row);
			$localtime = substr($localtime,0,5);

			if (length($subject) > $subject_length_max)
			{
				$subject = substr($subject,0,$subject_length_max);
				$subject .= "...";
			}

			$html_output .=qq~
	<TR>
		<TD BGCOLOR="$mesg_bgcolor">
			<img src="$imgurl/folder.gif">
			<a href="$mainurl/$forum/$num\.$ext"><FONT SIZE=2><b>$subject</b></FONT></a>
		</TD>
	      	<TD BGCOLOR="$mesg_bgcolor" ALIGN="CENTER"><FONT SIZE=2>$name</FONT></TD>      
      		<TD BGCOLOR="$mesg_bgcolor" ALIGN="CENTER" WIDTH="115"><FONT SIZE=2>$localtime $date</FONT></TD>
	      	<TD BGCOLOR="$mesg_bgcolor" ALIGN="CENTER"><FONT SIZE=2>$replies</FONT></TD>
	</TR>~;
		  
		}
		else
		{
			last;
		}
	   }

	$mesg_marker_p = $mm - $mesg_max; 
	$mesg_marker_n = $mm + $mesg_max; 
	$mesg_marker_b = 1 + $num_messages - $mesg_max;

	$html_output .=qq~
	<TR>
		<TD COLSPAN="4" BGCOLOR="$tablehead_bgcolor" ALIGN="CENTER"><font size=2>
			<A HREF="$boardurl?az=list&forum=$forum"><B>Nach oben</B></A>~;
	if ($mesg_marker_b > -1)
	{
		$html_output .=qq~
			<A HREF="$boardurl?az=list&forum=$forum&mm=$mesg_marker_b"><B>Nach unten</B></A>~;
	}
	if ($mesg_marker_p > -1)
	{
		$html_output .=qq~
			<A HREF="$boardurl?az=list&forum=$forum&mm=$mesg_marker_p"><B>Vorherige $mesg_max Beitrge</B></A>~;
	}
	if ($mesg_marker_n < $num_messages)
	{
		$html_output .=qq~
			<A HREF="$boardurl?az=list&forum=$forum&mm=$mesg_marker_n"><B>Weitere $mesg_max Beitrge</B></A>~;
	}

	$html_output .=qq~
			</font>
		</TD>
	</TR>
</TABLE>
</CENTER>
~;

} # Ende der Subroutine list

#-------------------------------------------
# Subroutine add_message
#-------------------------------------------

sub add_message
{
	$data_in = join("|",$num,$date,$localtime,$name,$subject,0);

	open(DATA,"$maindir/$forum/$database") || die $!;
	flock(DATA,2);
	@rowdata = <DATA>;
	flock(DATA,8);
	close(DATA);

	# Wenn die Anzahl der Zweige das festgelegte Maximum ueberschreitet, werden Zweige geloescht.
	# Zuvor wird allerdings sichergestellt, dass $max_threads_allowed definiert und nicht gleich 0 ist.

	if ($max_threads_allowed || ($max_threads_allowed > 0))
	{
		$num_threads = @rowdata;
		
		if ($num_threads >= $max_threads_allowed)
		{
			@prune_list = @rowdata[$max_threads_allowed-1..$num_threads];
			@rowdata = @rowdata[0..$max_threads_allowed-2];
			foreach $prune_file (@prune_list)
			{
				($p_num,@dummy) = split(/\|/, $prune_file);
				unlink("$maindir/$forum/$p_num\.$ext");
			}		
		}
	}

	# Zurueckschreiben in die Datenbank

	open(DATA,">$maindir/$forum/temp.data") || die $!;
	flock(DATA,2);
	print DATA "$data_in\n";
	print DATA @rowdata;
	flock(DATA,8);
	close(DATA);
	
	rename("$maindir/$forum/temp.data" , "$maindir/$forum/$database");   

} # Ende der Subroutine add_message

#-------------------------------------------
# Subroutine update_database
#-------------------------------------------

sub update_database
{
	open(DATA,"$maindir/$forum/$database") || die $!;
	flock(DATA,2);
	@rowdata = <DATA>;
	flock(DATA,8);
	close(DATA);

	foreach ($j = 0;$j <= @rowdata;$j++)
	{
		if ($rowdata[$j] =~ /^$om\|/)
		{
			($num,$origdate,$origtime,$origname,$origsubject,$replies) = split(/\|/, $rowdata[$j]);
			$replies ++;
			$new_data = join("|",$num,$date,$localtime,$origname,$origsubject,$replies);
			splice(@rowdata, $j, 1);
			$j --;
			last;
		}
	}

	open(DATA,">$maindir/$forum/temp.data") || die $!;
	flock(DATA,2);
	print DATA "$new_data\n";
	print DATA @rowdata;
	flock(DATA,8);
	close(DATA);

	rename("$maindir/$forum/temp.data" , "$maindir/$forum/$database");   

} # Ende der Subroutine update_database

#-------------------------------------------
# Subroutine create_message
#-------------------------------------------

sub create_message
{
	$orig_body =~ s/"/&quot;/g;

	$full_subject = $subject;

	$heading = "$full_subject";	 
	 
	if (length($subject) > $subject_length_max)
	{
		$subject = substr($subject,0,$subject_length_max);
		$subject .= "...";
	}

	$next_file_num = 0;
	$reply_to = 0;

	&html_main_body;

	$orig_mesg = $num;

	$html_output = "";
	$html_output .= qq~

<!-- HEADER:0:0 -->
<a name="TOP">$separator_img</a>
<FONT SIZE="2">
<CENTER>
<B>Inhaltsverzeichnis</B>
	<BR>...................................................................
</CENTER>
<BR>
<!-- MESSAGE:0:0 --><img src="$imgurl/blank.gif" width="0" height="14"><img src="$imgurl/folder.gif"> <a href="#0">$subject</a>, $name, $date, $localtime<BR>
<CENTER>
	<BR>...................................................................
</CENTER>
<BR>

<FORM ACTION="$boardurl" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="forum" VALUE="$forum">
	<INPUT TYPE="HIDDEN" NAME="om" VALUE="$num">

<!-- BEGIN_BODY:0 -->
$html_main_body
<!-- END_BODY:0 -->

<BR>
$separator_img
</FORM>
	~;

	open(TEMPLATE,"$templateurl") || die $!;
	flock(TEMPLATE,2);
	@rowdata = <TEMPLATE>;
	flock(TEMPLATE,8);
	close(TEMPLATE);

	foreach $row (@rowdata)
	{
		if (($row =~ /^#/) || ($row =~ /END_OF_HTML/) || ($row =~ /1;/) )
		{
		}
		elsif ($row =~ /<BODY/)
		{
			$new_row .= "<BODY BGCOLOR=\"#FFFFFF\" BACKGROUND=\"$bg_image\" LINK=\"$link_color\" VLINK=\"$vlink_color\" ALINK=\"$alink_color\" TEXT=\"$text_color\">\n";
		}
		#
		# Wenn links auf der Seite ein Leerraum bleiben soll, muss das Kommentarzeichen vor den naechsten beiden
		# Zeilen entfernt und das Abstandshalter-Gif auf die richtige Breite gesetzt werden.
		#
		# elsif ($row =~ /Blank Spacer/)
		# {
		#	$new_row .= "<img src=\"$imgurl/blank.gif\" alt=\"Blank Spacer\" width=\"125\" border=\"0\">\n";
		# }

		elsif ($row =~ /forum_banner/)
		{
			$new_row .= "<img src=\"$imgurl/$forum_banner\" alt=\"Bulletin Board Banner\" border=\"0\">\n";
		}
		elsif ($row =~ /separator_img/)
		{
			$new_row .= $separator_img . "\n";
		}
		elsif ($row =~ /title/)
		{
			$new_row .= "$title";
		}
		elsif ($row =~ /webmaster_email/)
		{
			$new_row .= "<a href=\"mailto:$webmaster_email\">Webmaster</a>\n";
		}
		elsif ($row =~ /<HEAD>/)
		{
			$new_row .= "<HEAD>\n";
			$new_row .= "<META HTTP-EQUIV=\"Expires\" CONTENT=\"Tues, 04 Dec 1996 21:00:00 GMT\">\n";
		}
		elsif ($row =~ /html_forum_links/)
		{
			$new_row .= "$html_forum_links";
		}
		elsif ($row =~ /menu_button/)
		{
			$new_row .= "$menu_button";
		}
		elsif ($row =~ /sub_heading/)
		{
			$new_row .= "Beitrge in diesem Zweig\n";
		}
		elsif ($row =~ /heading/)
		{
			$new_row .= "\"$heading\"";
		}
		elsif ($row =~ /html_output/)
		{
			$new_row .= "$html_output";
		}
		else
		{
			$new_row .= "$row";
		}
	}
	
	open(NEWMESG, ">$maindir/$forum/$num\.$ext") || die $!;
	flock(NEWMESG,2);
	print NEWMESG $new_row;
	flock(NEWMESG,8);
	close(NEWMESG);

} # Ende der Subroutine create_message


#-------------------------------------------
# Subroutine thread_message
#-------------------------------------------

sub thread_message
{
	$orig_body =~ s/"/&quot;/g;

	$num = $om;
	$full_subject = $subject;
   
	if (length($subject) > $subject_length_max)
	{
		$subject = substr($subject,0,$subject_length_max);
		$subject .= "...";
	}
      
	open(THREAD, "$maindir/$forum/$om\.$ext") || die $!;
	flock(THREAD,2);
	@rowdata = <THREAD>;
	flock(THREAD,8);
	close(THREAD);

	$new_row = "";
   
	foreach ($j = 0;$j <= @rowdata;$j++)
	{
		if ($rowdata[$j] =~ /<!-- HEADER:(.*):(.*) -->/)
		{
			$num_replies = $1 + 1;
			$next_file_num = $2 + 1;		 
			$new_row .= "<!-- HEADER:$num_replies:$next_file_num -->\n";
		}
		elsif ($rowdata[$j] =~ /<!-- MESSAGE:$rt:(.*) -->/)
		{
			$new_row .= "$rowdata[$j]";
			$level = $1 + 1;
			$space = $level * $level_spacing;
			$new_row .= "<!-- MESSAGE:$next_file_num:$level --><img src=\"$imgurl/blank.gif\" width=\"$space\" height=\"14\"><img src=\"$imgurl/file.gif\"> <a href=\"\#$next_file_num\">$subject</a>, $name, $localtime, $date<BR>\n";
		}
		elsif ($rowdata[$j] =~ /<!-- END_BODY:$rt -->/)
		{
			$new_row .= $rowdata[$j];
			$new_row .= "<!-- BEGIN_BODY:$next_file_num -->\n";
			$reply_to = $next_file_num;
			&html_main_body;
			$new_row .= "$html_main_body\n";
			$new_row .= "<!-- END_BODY:$next_file_num -->\n";
		}
		else
		{
			$new_row .= "$rowdata[$j]";
		}
	}

	open(THREAD, ">$maindir/$forum/$om\.$ext") || die $!;
	flock(THREAD,2);
	print THREAD $new_row;
	flock(THREAD,8);
	close(THREAD);

} # Ende der Subroutine thread_message


#-------------------------------------------
# Subroutine display_status
#-------------------------------------------

sub display_status
{
	$orig_body =~ s/"/&quot;/g;

	$type = $_[0];	

	# Vorschau
	if ($type eq "pview")
	{
		$heading = "Vorschau auf Beitrag: $subject";
		$sub_heading = "Wenn Sie diesen Beitrag ndern mchten, klicken Sie auf <B><I>Zurck</I></B> in Ihrem Browser und schicken ihn erneut ab.";
	  	  
		$html_output .= qq~
	$separator_img<BR>
	<b>Betrifft:</b> $subject<br>
	<b>Name:</b> $name<br>
	<b>E-Mail:</b> $email<br>
	<B>Datum:</b> $date<BR>
	<b>Beitrag:</b><p>
	<BLOCKQUOTE>
		$body<p>
	</BLOCKQUOTE>
		~;
		
		if ($homepage)
		{
			$html_output .= "<b>URL:</b> $homepage<br>\n";
		}
		if ($banner_url)
		{
			$html_output .= "<b>Banner:</b> $banner_url<br>\n";
		}
	
		$html_output .= qq~
	$separator_img
<CENTER>
<form ACTION="$boardurl" method="POST">
	<input type=hidden name="om" value="$om">
	<input type=hidden name="rand1" value="$in{'rand1'}">
	<input type=hidden name="rt" value="$rt">
	<input type=hidden name="forum" value="$forum">
	<input type=hidden name="az" value="a_mesg">
	<input type=hidden name="name" value="$name">
	<input type=hidden name="email" value="$email">
	<input type=hidden name="subject" value="$subject">
	<input type=hidden name="body" value="$orig_body">
	<input type=hidden name="url" value="$homepage">
	<input type=hidden name="banner_url" value="$banner_url">

	<B>Wollen Sie diesen Beitrag abschicken?</B><P>
	<input type="submit" value="Beitrag abschicken"> <input type="button" value="Beitrag ndern" onClick="javascript:history.back()">
</form>
</CENTER>
		~;
	}

	# Namensangabe vergessen
	elsif ($type eq 'no_name')
	{   
		$html_output .= qq~
	<h2 ALIGN="CENTER"><font color="$headingcol">FEHLER: Kein Name</font></h2>
      <H3 ALGIN="CENTER">Sie haben das Namensfeld in Ihrem Beitrag nicht ausgefllt.</h3>
      <H4 ALIGN="CENTER">Sie mssen Name, Betreff und die Mitteilung eingeben. Bitten benutzen Sie den Button 
	<b><i>Zurck</i></b> in Ihrem Browser und vervollstndigen Sie das Formular.</H4>~;
	}

	# Thema vergessen
	elsif ($type eq 'no_subject')
	{
		$html_output .= qq~
	<h2 ALIGN="CENTER"><font color="$headingcol">FEHLER: Kein Betreff</font></h2>
      <H3 ALGIN="CENTER">Sie haben das Feld 'Betrifft' in Ihrem Beitrag nicht ausgefllt.</h3>
      <H4 ALIGN="CENTER">Sie mssen Name, Betreff und die Mitteilung eingeben. Bitten benutzen Sie den Button 
	<b><i>Zurck</i></b> in Ihrem Browser und vervollstndigen Sie das Formular.</H4>~;
	}

	# Mitteilung vergessen
	elsif ($type eq 'no_body')
	{
		$html_output .= qq~
	<h2 ALIGN="CENTER"><font color="$headingcol">FEHLER: Keine Mitteilung</font></h2>
      <H3 ALGIN="CENTER">Sie haben das Feld 'Mitteilung' in Ihrem Beitrag nicht ausgefllt.</h3>
      <H4 ALIGN="CENTER">Sie mssen Name, Betreff und die Mitteilung eingeben. Bitten benutzen Sie den Button 
	<b><i>Zurck</i></b> in Ihrem Browser und vervollstndigen Sie das Formular.</H4>~;
	}

	# Sonstiger Fehler
	else
	{
		$html_output .= "Allgemeiner Fehler\n";
	}

	require "$templateurl";
	exit(0);

} # Ende der Subroutine display_status

#-------------------------------------------
# Subroutine get_number
#-------------------------------------------

sub get_number
{
	open(NUMBER,"$maindir/$forum/$datafile");
	flock(NUMBER,2);
	$num = <NUMBER>;
	flock(NUMBER,8);
	close(NUMBER);
	if ($num == 999999)
	{
		$num = "1";
	}
	else
	{
		if ($om == 0)
		{
			$num++;
		}
	}

	open(NUM,">$maindir/$forum/$datafile") || die $!;
	flock(NUMBER,2);
	print NUM "$num";
	flock(NUMBER,8);
	close(NUM);

} # Ende der Subroutine get_number

#-------------------------------------------
# Subroutine get_variables
#-------------------------------------------

sub get_variables
{
	if ($in{"forum"})
	{
		$forum=$in{"forum"};
	}

	if ($in{"mm"})
	{
		$mm = $in{"mm"};
	}
	else
	{
		$mm = 0;
	}
	
	if ($in{"om"})
	{
		$om = $in{"om"};
		$rt = $in{"rt"};
	}
	else
	{
		$om = 0;
	}

} # Ende der Subroutine get_variables

#-------------------------------------------
# Subroutine get_form_variables
#-------------------------------------------

sub get_form_variables
{
	if ($in{'name'})
	{
		$name = "$in{'name'}";
	}
	else
	{
		&display_status(no_name);
	}

	if ($in{'email'} =~ /.*\@.*\..*/)
	{
		$email = "$in{'email'}";
	}

	if ($in{'subject'})
	{
		$subject = "$in{'subject'}";
		$subject =~ s/\&/\&amp\;/g;
		$subject =~ s/"/\&quot\;/g;
	}
	else
	{
		&display_status(no_subject);
	}

	if ($in{'url'})
	{
		if ($in{'url'} =~ /^http/)
		{
			$homepage = $in{'url'};
		}
		else
		{
			$homepage = "http://"."$in{'url'}";
		}
	}

	if ($in{'body'})
	{
		$body = $in{"body"};
		$body =~ s/\cM//g;

		$orig_body = $body;

		$body =~ s/\n\n/<P>/g;
		$body =~ s/\n/<BR>/g;
		$body =~ s/&quot;/"/g;
	}
	else
	{
		&display_status(no_body);
	}

	if ($in{'banner_url'})
	{
		if ($in{'banner_url'} =~ /^http/)
		{
			$banner_url = $in{'banner_url'};
		}
		else
		{
			$banner_url = "http://" . "$in{'banner_url'}";
		}
		$banner_img = "<img src=\"$banner_url\" border=\"0\">";
	}

} # Ende der Subroutine get_form_variables


#-------------------------------------------
# Subroutine get_date
#-------------------------------------------

sub get_date
{
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);

	if ($sec < 10)	{ $sec = "0$sec"; }
	if ($min < 10)	{ $min = "0$min"; }
	if ($hour < 10)	{ $hour = "0$hour"; }
	if ($mday < 10)	{ $mday = "0$mday"; }

	$month = ($mon + 1);
	if ($month < 10)	{ $month = "0$month"; }

	@months = ("Januar","Februar","Mrz ","April","Mai","Juni","Juli","August","September","Oktober","November","Dezember");

	$localtime = "$hour\:$min\:$sec";
	$date = "$mday\.$month\.$year";
	chop($date) if ($date =~ /\n$/);
	chop($local) if ($local =~ /\n$/);
   
	$last_read = (($year - 97) * 372 * 86400) + ($month * 31 * 86400) + (($mday - $days) * 86400) + ($hour * 3600) + ($min * 60) + $sec;

} # Ende der Subroutine get_date

#-------------------------------------------
# Subroutine create_button
#-------------------------------------------

sub create_button
{
	$type = $_[0];

	$menu_buttons = "";

	if ($type eq 'list_forums')
	{
	}
	elsif ($type eq 'list')
	{
		$menu_buttons .=qq~
	<a href="$boardurl?az=post&forum=$forum"><img src="$imgurl/post.gif" alt="Neubeitrag einreichen" border="0"></a>
	<a href="$boardurl"><img src="$imgurl/mainforum.gif" alt="Hauptmen" border="0"></a>
		~;
	}
} # Ende der Subroutine create_button

#-------------------------------------------
# Subroutine post
#-------------------------------------------

sub post
{
	$heading = $heading_post;
	$sub_heading = $sub_heading_post;
	
	$html_output .=qq~
<center>
<form action="$boardurl" method="POST">
	<input type=hidden name="rand1" value="$rand1">
	<input type=hidden name="om" value="$in{'om'}">
	<input type=hidden name="rt" value="$rt">
	<input type=hidden name="forum" value="$in{'forum'}">
	<input type=hidden name="az" value="pview">
	
<TABLE CELLPADDING="2" BORDER="0" WIDTH="100%">
	<TR>
		<TH ALIGN="RIGHT"><FONT SIZE=2>Name: </FONT></TH>
		<TD><INPUT TYPE="TEXT" NAME="name" SIZE=50></TD>
	</TR>
	
	<TR>
		<TH ALIGN="RIGHT"><FONT SIZE=2>E-Mail: </FONT></TH>
		<TD><INPUT TYPE="TEXT" NAME="email" SIZE=50></TD>
	</TR>
	
	<TR>
		<TH ALIGN="RIGHT"><FONT SIZE=2> Betrifft: </FONT></TH>
		<TD><INPUT TYPE="TEXT" NAME="subject" SIZE=45></TD>
	</TR>
	
	<TR>
		<TH ALIGN="RIGHT" VALIGN="TOP"><FONT SIZE=2>Mitteilung: </FONT></TH>
		<TD><TEXTAREA NAME="body" ROWS="10" COLS="45" WRAP="physical"></TEXTAREA></TD>
	</TR>
	
	<TR>
		<TH ALIGN="RIGHT"><FONT SIZE=2>Homepage: </FONT></TH>
		<TD><B><font color="$link_color">http://</font></B> <INPUT TYPE="TEXT" NAME="url" SIZE=40></TD>
	</TR>

	<TR>
		<TH ALIGN="RIGHT"><FONT SIZE=2>Banner: </FONT></TH>
		<TD><B><font color="$link_color">http://</font></B> <INPUT TYPE="TEXT" NAME="banner_url" SIZE=40></TD>
	</TR>

	<TR>
		<TH ALIGN="RIGHT"></TH>
		<TD>
			<INPUT TYPE="SUBMIT" NAME="preview_option" VALUE="Vorschau auf Beitrag">
			<INPUT TYPE="SUBMIT" NAME="post_option" VALUE="Beitrag abschicken">
			<INPUT TYPE="RESET" VALUE="Formular lschen" onClick="return ResetCheck()">
		</TD>
	</TR>
</TABLE>
</form>
</center>
	~;
	

} # Ende der Subroutine post


#--------------------------------------------
# Subroutine new_messages
#--------------------------------------------

sub new_messages
{
	$heading = $heading_new_messages;
	$sub_heading = $sub_heading_new_messages;
   
	&get_table_heading;
   
	$html_output .= qq~
<CENTER>
<TABLE BORDER="0" CELLPADDING="0" WIDTH="100%">
	~;

	$any_hits = "no";
	
	foreach $forum (@forums)
	{
		$hit = "no";
		$html_new_mesg = "";	  
		$fullpath = "$maindir/$forum";

		open(DATA,"$fullpath/$database") || die $!;
		flock(DATA,2);
		@rowdata = <DATA>;
		flock(DATA,8);
		close(DATA);

		foreach $row (@rowdata)
		{
			($num,$date,$localtime,$name,$subject,$replies) = split(/\|/, $row);
			$localtime = substr($localtime,0,5); 

			if (length($subject) > $subject_length_max)
			{
				$subject = substr($subject,0,$subject_length_max);
				$subject .= "...";
			}
			
			if ($last_read)
			{
				($hh,$minute,$second) = split(/\:/, $localtime);
				($dd,$mmonth,$yy) = split(/\./, $date);
				$mesg_mark = (($yy - 97) * 372 * 86400) + ($mmonth * 31 * 86400) + ($dd * 86400) + ($hh * 3600) + ($minute * 60) + $second;
		
				if ($mesg_mark > $last_read)
				{
					$hit = "yes";
					$html_new_mesg .=qq~
	<TR>
		<TD>
			<img src="$imgurl/folder.gif">
			<a href="$mainurl/$forum/$num\.$ext"><FONT SIZE=2><b>$subject</b></FONT></a>
		</TD>
		<TD ALIGN="CENTER"><FONT SIZE=2>$name</FONT></TD>      
		<TD ALIGN="CENTER" WIDTH="115"><FONT SIZE=2>$date \- $localtime</FONT></TD>
		<TD ALIGN="CENTER"><FONT SIZE=2>$replies</FONT></TD>
	</TR>
					~;
			
				}
				else
				{
					last;
				}
			}
		}

		if ($hit eq "yes")
		{
			$any_hits = "yes";
			$html_output .=qq~
	<TR>
		<TH ALIGN="CENTER" COLSPAN="4">Nee Beitrge im Forum $forum_name{"$forum"}</TH>
	</TR>
			~;
			   
			$html_output .= $table_heading;
			$html_output .= $html_new_mesg;
		}
	}
   
	if ($any_hits eq "no")
	{
		$html_output .=qq~
	<TR>
		<TH ALIGN="CENTER">Whrend der letzten $days Tage wurden keine neuen Beitrge eingereicht.</TH>
	</TR>
		~;
	}

	$html_output .= "</TABLE>\n";  

} # Ende der Subroutine new_messages


#--------------------------------------------
# Subroutine get_table_heading
#--------------------------------------------

sub get_table_heading
{
	$table_heading .= qq~
	<TR>
		<TD BGCOLOR="$tablehead_bgcolor" ALIGN="CENTER"><font color="$mesg_font_color"><b>Thema</b></font></TD>
		<TD BGCOLOR="$tablehead_bgcolor" ALIGN="CENTER"><font color="$mesg_font_color"><b>Eingereicht von</b></font></TD>
		<TD BGCOLOR="$tablehead_bgcolor" ALIGN="CENTER" WIDTH="115"><font color="$mesg_font_color"><b>Zuletzt modifiziert</b></font></TD>
		<TD BGCOLOR="$tablehead_bgcolor" ALIGN="CENTER"><font color="$mesg_font_color"><b>Antworten</b></font></TD>
	</TR>
	~;

} # Ende der Subroutine get_table_heading

#------------------------------------
# Subroutine html_main_body
#------------------------------------

sub html_main_body
{
	$html_main_body .= qq~
<a name="$next_file_num">$separatorimg</a>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" BGCOLOR="$mesg_bgcolor">
	<TR>
		<TH width="115" align="right"><FONT SIZE="2" COLOR="$mesg_font_color"><B>Betrifft</B>:</Font></TH>
		<TD><FONT SIZE="2" COLOR="$headingcol"><b>$full_subject</b></FONT></td>
	</TR>

	<TR>
		<TH width="115" align="right"><FONT SIZE="2" COLOR="$mesg_font_color"><B>Name</B>:</FONT></TH>
		<TD><FONT SIZE="2" COLOR="$mesg_font_color">$name</FONT></TD>
	</TR>

	<TR>
		<TH width="115" align="right"><FONT SIZE="2" COLOR="$mesg_font_color"><B>Datum - Zeit</B>:</FONT></TH>
		<TD><FONT SIZE="2" COLOR="$mesg_font_color">$date \- $localtime</FONT></TD>
	</TR>

	<TR>
		<TH width="115" align="right" valign="top"><FONT SIZE="2" COLOR="$mesg_font_color"><B>Mitteilung:</B></FONT></TH>
		<TD><FONT SIZE="3" COLOR="$mesg_font_color">$body</FONT></TD>
	</TR>
	~;

	if ($banner_url)
	{
		$html_main_body .= qq~
	<TR>
		<TH width="115" align="right" valign="top"><FONT SIZE="2" COLOR="$mesg_font_color"><B>Banner:</B></FONT></TH>
		<TD><FONT SIZE="2" COLOR="$mesg_font_color">$banner_img</FONT></TD>
	</TR>
		~;
	}

	$html_main_body .= qq~
	<TR>
		<TD COLSPAN="2" ALIGN="RIGHT"><BR>
	~;
		 
	if ($homepage)
	{
		$html_main_body .= "		<a href=\"$homepage\"><IMG SRC=\"$imgurl/homepage.gif\" alt=\"Homepage des Verfassers\" border=\"0\"></a>\n";
	}

	if ($email)
	{
		$html_main_body .= "		<a href=\"mailto:$email\"><IMG SRC=\"$imgurl/email.gif\" alt=\"Email an Verfasser\" border=\"0\"></a>\n";
	}

	$html_main_body .= qq~
			<INPUT TYPE="IMAGE" NAME="$reply_to" SRC="$imgurl/reply.gif" alt="Antwort auf diesen Beitrag" BORDER="0">
			<a href="\#TOP"><IMG SRC="$imgurl/top.gif" alt="Zum Dokumentenanfang" border="0"></a> 
			<INPUT TYPE="IMAGE" NAME="Main" SRC="$imgurl/home.gif" alt="Zu diesem Forum" BORDER="0">
			<INPUT TYPE="IMAGE" NAME="Lobby" SRC="$imgurl/mainforum.gif" alt="Zum Hauptmen (alle Foren)" BORDER="0">
		</TD>
	</TR>
</TABLE>
	~;

} # Ende der Subroutine html_main_body

#------------------------------------
# Subroutine forum_links
#------------------------------------

sub forum_links
{
	$html_forum_links .= qq~
<!-- BEGIN FORUM LINKS -->
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1">
	<TR>
		<TD ALIGN="CENTER" VALIGN="TOP">
			<FONT SIZE="2" COLOR="$mesg_font_color"><b> | ~;

		foreach $forum (@forums)
		{  
			$html_forum_links .= qq~
			<a href="$boardurl?az=list&forum=$forum">$forum_name{$forum}</a> | ~;
   		}  

	$html_forum_links .= qq~
			</b></FONT>
		</TD>
	</TR>
</TABLE>
<!-- END FORUM LINKS -->
	  ~;

} # Ende der Subroutine forum_links
