#!/usr/bin/perl
#
# html_template.pl
# Output Template Script for DCForum97
# Product of DCScripts, www.sitedeveloper.com/scripts
# Written By David S. Choi, dc@sitedeveloper.com
# 10 August 1997
# Last Revision Date: 10 Aug 1997
#
# html_template.pl is the output template for DCForum97 scripts
# Scripts using html_template.pl are dcboard97.cgi, dcadmin97.cgi, 
# and auth_extra_html.pl
# You can create your own output display simply by editing this file.
# Following parameters are passed from other scripts
#
# $title - title in the heading section
# $heading - heading in the main page
# $sub_heading - sub heading in the main page
# $menu_buttons - buttons and links for the forum
# $html_forum_links - links to other forums
# $link_color, $vlink_color, $alink_color - text color associated with hyperlink
# $imgurl - location of Images URL
#
# Copyright  1997 DCScripts All Rights Reserved
# As part of the installation process, you will be asked
# to accept the terms of this Agreement. This Agreement is
# a legal contract, which specifies the terms of the license
# and warranty limitation between you and DCScripts and DCForum97.
# You should carefully read the following terms and conditions before
# installing or using this software.  Unless you have a different license
# agreement obtained from DCScripts, installation or use of this software
# indicates your acceptance of the license and warranty limitation terms
# contained in this Agreement. If you do not agree to the terms of this
# Agreement, promptly delete and destroy all copies of the Software.
#
# Versions of the Software 
# Only one copy of the registered version of DCForum97 may used on one web site.
# 
# License to Redistribute
# Distributing the software and/or documentation with other products
# (commercial or otherwise) or by other than electronic means without
# DCScripts's prior written permission is forbidden.
# All rights to the DCForum97 software and documentation not expressly
# granted under this Agreement are reserved to DCScripts.
#
# Disclaimer of Warranty
# THIS SOFTWARE AND ACCOMPANYING DOCUMENTATION ARE PROVIDED "AS IS" AND
# WITHOUT WARRANTIES AS TO PERFORMANCE OF MERCHANTABILITY OR ANY OTHER
# WARRANTIES WHETHER EXPRESSED OR IMPLIED.   BECAUSE OF THE VARIOUS HARDWARE
# AND SOFTWARE ENVIRONMENTS INTO WHICH DCFORUM97 MAY BE USED, NO WARRANTY OF
# FITNESS FOR A PARTICULAR PURPOSE IS OFFERED.  THE USER MUST ASSUME THE
# ENTIRE RISK OF USING THIS PROGRAM.  ANY LIABILITY OF HKDESIGN WILL BE
# LIMITED EXCLUSIVELY TO PRODUCT REPLACEMENT OR REFUND OF PURCHASE PRICE.
# IN NO CASE SHALL DCSCRIPTS BE LIABLE FOR ANY INCIDENTAL, SPECIAL OR
# CONSEQUENTIAL DAMAGES OR LOSS, INCLUDING, WITHOUT LIMITATION, LOST PROFITS
# OR THE INABILITY TO USE EQUIPMENT OR ACCESS DATA, WHETHER SUCH DAMAGES ARE
# BASED UPON A BREACH OF EXPRESS OR IMPLIED WARRANTIES, BREACH OF CONTRACT,
# NEGLIGENCE, STRICT TORT, OR ANY OTHER LEGAL THEORY. THIS IS TRUE EVEN IF
# DCSCRIPTS IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. IN NO CASE WILL
# DCSCRIPTS' LIABILITY EXCEED THE AMOUNT OF THE LICENSE FEE ACTUALLY PAID
# BY LICENSEE TO DCSCRIPTS. 
#
# CREDITS:
# The authentication code is the work of Selena Sol and Gunther Berznick
# You can obtain it from Selena Sol's Public Domain Script Archive
# at http://selena.mcp.com/Scripts/ or you can purchase their book
# "Instant Web Scripts with CGI/PERL" -- Great Book!
# cgi-lib.pl was written by Stephen Brenner.
#------------------------------------------------------

print <<__END_OF_HTML__;

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">

<HTML>
<HEAD>
<TITLE>
$title
</TITLE>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
<SCRIPT LANGUAGE="javascript" SRC="http://www.gb-direkt.de/publik/dcforum97/chckform.js" TYPE="text/javascript">
</SCRIPT>
</HEAD>

<!-- Leave following line as is -->
<BODY BGCOLOR="#FFFFFF" BACKGROUND="$bg_image" LINK="$link_color" VLINK="$vlink_color" ALINK="$alink_color" TEXT="$text_color">
<font face="verdana, arial, helvetica">
<CENTER>
<TABLE BORDER="0" WIDTH="90%" ALIGN="CENTER">
	<TR>
		<TD>
		<table border="0" width="100%">
			<TR>
				<td align="center">
					<!-- Leave following line as is -->
					<img src="$imgurl/$forum_banner" alt="Bulletin Board Banner" border="0">
					<P> 
					<FONT FACE="times, serif, palatino" SIZE="2">
					<!-- Leave following line as is -->
					$html_forum_links
					</FONT>
					<P>
					<!-- Leave following line as is -->
					$menu_buttons
					<P>
					<H2><FONT COLOR="#003366" FACE="verdana, arial, helvetica">
					<!-- Leave following line as is -->
					$heading
					</FONT></H2>
					<P>
					<H3><FONT FACE="verdana, arial, helvetica">
					<!-- Leave following line as is -->
					$sub_heading
					</FONT></h3><P>
				</td>
			</tr>
		
			<tr>
				<td>
					<!-- Leave following line as is -->
					$html_output 
				</td>
			</tr>

			<tr>
				<td>&nbsp; <P></td>
			</tr>
				
			<tr>
					<TD ALIGN="center">
					<!-- Leave following line as is -->
					$separator_img
					<br>
					<small><small>Fragen oder Probleme bezglich der Plauderstube sollten an den 
					<!-- Leave following line as is -->
					<a href="mailto:$webmaster_email">Webmaster</a>
					gerichtet werden.
					<br>
					&copy;1997 by <a href="http://www.sitedeveloper.com">DCScripts</a>. Alle Rechte vorbehalten.<br>
					Deutsche bersetzung: <a href="mailto:Bigorajski\@T-Online.de">Gerold Bigorajski</a>.</small></small>
				</td>
			</tr>	
		</table></td>
	</tr>
</table>
</CENTER>
</BODY>
</HTML>

__END_OF_HTML__


1;
