############################################################
#                       AUTH-SERVER-LIB.PL
#
# Dieses Script wurde von Selena Sol & Gunther Birznieks geschrieben. 
# Urspruengliche Programmierung:	10.05.96
# Letzte Aenderung:			14.05.96
# Deutsche Uebersetzung: Gerold Bigorajski
#
#   Es darf unter den Bedingungen der GNU General Public
#   License oder der Artistic License, die zusammen mit
#   Perl v5.x fr UNIX verteilt wird, kopiert werden.
# 
# Selena Sol kann unter selena@eff.org kontaktiert werden.
# Gerold Bigorajski ist unter bigorajski@t-online.de erreichbar.
#
# Zweck: Dieses Script enthaelt die auf Ihren Server zugeschnittenen
# Routinen, falls Sie server-basierte Authentisierung verwenden.
# 
# Diese Datei wurde als Beispiel mit integriert. Sie fuehrt tatsaechlich
# nichts gueltiges durch. Wenn Sie diese Bibliothek fuer ein Intranet
# verwenden, wird es diverse Geschaeftsregeln und Datenbanken geben,
# die Sie moeglicherweise integrieren wollen.
#
# Hauptprozeduren:
#   Eine Prozedur, um server-basierte Authentiserung durchzufuehren.
#   $username wurde vorher auf in auth-extra-lib.pl auf REMOTE_USER
#   gesetzt.
#
############################################################

# Anmerkung: $username ist bereits gesetzt.
#
#
# Hier wuerden Sie eine Routine aufrufen, um die andderen Variablen
# auszufuellen, vorzugsweise von einer vorhandenen Datenbank - z.B.
# einem Adressbuch in Sybase or Oracle.
# 
# Da dies ein generisches Script ist, wird einfach etwas grundlegende
# Logik zur Verfuegung gestellt, um zu zeigen, wie es funktioniert.

$firstname = "Gunther";
$lastname = "Birznieks";
$email = "gunther@gunther.com";
$group = "$auth_default_group";

$session = &MakeSessionFile( ($username, $group, $firstname, $lastname, $email));

1;

